=== debian/changelog ===
git (1:2.17.1-1ubuntu0.18) bionic-security; urgency=medium

  * SECURITY UPDATE: Overwriting path
    - debian/patches/CVE-2023_25652_25815_29007/0022-*.patch: apply
      --reject overwriting existing .rej symlink if it exists in apply.c,
      t/t4115-apply-symlink.sh.
    - CVE-2023-25652
  * SECURITY UPDATE: Malicious placement of crafted messages
    - debian/patches/CVE-2023_25652_25815_29007/0024-*patch:
      avoid using gettext if the locale dir is not present in
      gettext.c.
    - CVE-2023-25815
  * SECURITY UPDATE: Arbitrary configuration injection
    - debian/patches/CVE-2023_25652_25815_29007/0025-*.patch: avoid
      fixed-sized buffer when renaming/deleting a section in config.c.
    - debian/patches/CVE-2023_25652_25815_29007/0026-*.patch: avoid
      integer truncation in copy_or_rename_section_in_file() in config.c.
    - debian/patches/CVE-2023_25652_25815_29007/0027-*.patch: disallow
      overly-long lines in copy_or_rename_section_in_file in config.c.
    - CVE-2023-29007

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Wed, 26 Apr 2023 11:14:45 -0300

git (1:2.17.1-1ubuntu0.17) bionic-security; urgency=medium

  * SECURITY REGRESSION: Adding missing parts of CVE-2023-22490
    local repository clone when .git/objects is a symlink
    - debian/patches/CVE_2023_22490_and_23946/0001-dir-iterator-refactor*.patch
    - debian/patches/CVE_2023_22490_and_23946/0005-dir-iterator-add-flags*.patch
      (LP: #2008277).

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Mon, 27 Feb 2023 11:27:06 -0300

git (1:2.17.1-1ubuntu0.16) bionic-security; urgency=medium

  * SECURITY UPDATE: Overwritten path and using
    local clone optimization even when using a non-local transport
    - debian/patches/CVE_2023-22490_and_23946/0002-*.patch: adjust
      a mismatch data type in attr.c.
    - debian/patches/CVE_2023-22490_and_23946/0003-*.patch: demonstrate
      clone_local() with ambiguous transport in
      t/t5619-clone-local-ambiguous-transport.sh.
    - debian/patches/CVE_2023-22490_and_23946/0004-*.patch: delay
      picking a transport until after get_repo_path() in builtin/clone.c.
    - debian/patches/CVE_2023-22490_and_23946/0006-*.patch: fix writing behind
      newly created symbolic links in apply.c, t/t4115-apply-symlink.sh.
    - CVE-2023-22490
    - CVE-2023-23946

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Wed, 08 Feb 2023 12:09:34 -0300

git (1:2.17.1-1ubuntu0.15) bionic-security; urgency=medium

  * SECURITY REGRESSION: Previous update was incomplete what could causes regressions
    - debian/patches/CVE_2022_23521_and_41903/0012-*.patch: update patch with
      missed parts (LP: #2003246).

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Thu, 19 Jan 2023 08:37:09 -0300

git (1:2.17.1-1ubuntu0.14) bionic-security; urgency=medium

  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE_2022_23521_and_41903/00*.patch:
      attr.c, attr.h, pretty.c, column.c, utf8.c, utf8.h,
      t/t4205-log-pretty-formats.sh, t/test-lib.sh, git-compat-util.h,
      t/t0003-attributes.sh.
    - CVE-2022-23521
    - CVE-2022-41903

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Thu, 12 Jan 2023 11:48:11 -0300

git (1:2.17.1-1ubuntu0.13) bionic-security; urgency=medium

  * SECURITY UPDATE: Unexpected behavior
    - debian/patches/CVE-2022-39253-*.patch: disallow --local
      clones with symlinks and additionally changed the
      protocol.file.allow to be user by default in
      builtin/clone.c, transport.c, and modified tests in
      t/t5604-clone-reference.sh,
      lib-submodule-update.sh, t/t1091-sparse-checkout-builtin.sh,
      t/t1500-rev-parse.sh, t/t2400-worktree-add.sh,
      t/t2403-worktree-move.sh, t/t2405-worktree-submodule.sh,
      t/t3200-branch.sh, t/t3420-rebase-autostash.sh,
      t/t3426-rebase-submodule.sh, t/t3512-cherry-pick-submodule.sh,
      t/t3600-rm.sh, t/t3906-stash-submodule.sh,
      t/t4059-diff-submodule-not-initialized.sh,
      t/t4060-diff-submodule-option-diff-format.sh,
      t/t4067-diff-partial-clone.sh,
      t/t4208-log-magic-pathspec.sh, t/t5510-fetch.sh,
      t/t5526-fetch-submodules.sh, t/t5545-push-options.sh,
      t/t5572-pull-submodule.sh, t/t5601-clone.sh,
      t/t5614-clone-submodules-shallow.sh, t/t5616-partial-clone.sh,
      t/t5617-clone-submodules-remote.sh, t/t6008-rev-list-submodule.sh,
      t/t6134-pathspec-in-submodule.sh,
      t/t7001-mv.sh, t/t7064-wtstatus-pv2.sh,
      t/t7300-clean.sh, t/t7400-submodule-basic.sh,
      t/t7403-submodule-sync.sh, t/t7406-submodule-update.sh,
      t/t7407-submodule-foreach.sh, t/t7408-submodule-reference.sh,
      t/t7409-submodule-detached-work-tree.sh, t/t7411-submodule-config.sh,
      t/t7413-submodule-is-active.sh, t/t7414-submodule-mistakes.sh,
      t/t7415-submodule-names.sh, t/t7416-submodule-dash-url.sh,
      t/t7417-submodule-path-url.sh, t/t7418-submodule-sparse-gitmodules.sh,
      t/t7419-submodule-set-branch.sh, t/t7420-submodule-set-url.sh,
      t/t7421-submodule-summary-add.sh, t/t7506-status-submodule.sh,
      t/t7507-commit-verbose.sh, t/t7800-difftool.sh,
      t/t7814-grep-recurse-submodules.sh, t/t9304-fast-import-marks.sh,
      t/t9350-fast-export.sh, t/t1092-sparse-checkout-compatibility.sh,
      t/t2080-parallel-checkout-basics.sh, t/t7450-bad-git-dotfiles.sh.
    - CVE-2022-39253
  * SECURITY UPDATE: Arbitrary heap writes
    - debian/patches/CVE-2022-39260-*.patch: limit size of interactive
      commands and reject too-long cmdline strings in split cmdline()
      in shell.c, t/t9850-shell.sh, alias.c.
    - CVE-2022-39260

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Fri, 14 Oct 2022 11:15:33 -0300

git (1:2.17.1-1ubuntu0.12) bionic-security; urgency=medium

  * SECURITY UPDATE: Potential arbitrary code execution
    - debian/patches/CVE-2022-29187-1.patch: adds test to
      regression git needs safe.directory when using sudo in

